<?php
/*
The script to display links to all posts containing <img> tags pointing to external images via 'http' (and not 'https'). Useful to check whatever insecure images are included to your possibly secured forum.
This file is part of miniBB. miniBB is free discussion forums/message board software, supplied with no warranties.
Check COPYING file for more details.
Copyright (C) 2020 Paul Puzyrev. www.minibb.com
Latest File Update: 2020-Mar-20
*/

define ('INCLUDED776',1);
//archives
//define('ARCHIVE', '2005-2009');

include('./setup_options.php');

include($pathToFiles.'setup_'.$DB.'.php');
include($pathToFiles.'bb_functions.php');
include($pathToFiles.'bb_specials.php');

/* Optional Settings - they should do work with no modifying, and are for debugging/experienced coders only. */

//$purgeSortOrder='topic_id ASC, post_id ASC';

//$purgeTbs=array($Tt, $Tp, '2co_orders'); //name of the posts table
$purgeTbs=array($Tp); //name of the posts table

$purgeFields=array();

$purgeFields[$Tp]=array('post_text', 'forum_id');

$purgeIds=array(
$Tp=>'post_id',
);  //the unique IDs of tables

$purgeGoPost=$main_url.'/msg.php?id=[POST_ID]';

$recordsLimit=30000; //the portion of selected records AT ONCE

$purgeLimited=FALSE; // the output will be limited to $recordsLimit amount only

$checkClosedForums=TRUE; // if TRUE, the script will check Closed Forums; FALSE if not

$brtag='<br />';

/* --Optional Settings */


set_time_limit(0);

function get_microtime() {
$mtime=explode(' ',microtime());
return $mtime[1]+$mtime[0];
}

$starttime=get_microtime();
if(!defined('PAGE1_OFFSET')) define('PAGE1_OFFSET', 0);

$cnt=0;
$cntTotal=0;

echo <<<out
<!doctype html>
<html>
<head>
<title>External [IMG] Finding</title>
<meta http-equiv="content-type" content="text/html;charset=utf8" />
<link href="{$main_url}/css/default.css" type="text/css" rel="stylesheet">
</head>
<body class="gbody" style="background:#fff">
out;

foreach($purgeTbs as $purgeTb){

$selectedFields='';
foreach($purgeFields[$purgeTb] as $pf){
$selectedFields.=$pf.', ';
}
$selectedFields=substr($selectedFields, 0, strlen($selectedFields)-2);

//echo $selectedFields; exit;

$sql="select count(*) from {$purgeTb}";

if($res=mysqli_query($mysqlink, $sql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res)) $numRows=$row[0]; else $numRows=0;

echo 'Total Records in `'.$purgeTb.'`: <b>'.$numRows.'</b><br /></b><br /><hr size="1" style="color:#ccc"><br />';

$cont='';

if($purgeLimited) $numRows=$recordsLimit;

if($numRows>0){

/****************/

$startOffset=0;
$currRec=0;
$supposeConverted=0;
$firstPageMsgs=0;
$nextPageMsgs=0;

while($startOffset<$numRows){

$sql="select {$purgeIds[$purgeTb]}, {$selectedFields} from {$purgeTb} order by {$purgeIds[$purgeTb]} asc limit {$startOffset}, {$recordsLimit}";

if($res=mysqli_query($mysqlink, $sql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res)){

do{

$foundq=FALSE;
$idCurrent=$row[0];
$ptextCurrent=strtolower($row[1]);

if(!in_array($row[2], $clForums) or (in_array($row[2], $clForums) and $checkClosedForums)){

if(substr_count($ptextCurrent, '<img src="http://')>0) {

echo '&nbsp;&nbsp;<a href="'.str_replace('[POST_ID]', $row[0], $purgeGoPost).'" target="_blank">'.$row[0].'</a><br>';

$supposeConverted++;

}

}

}
while($row=mysqli_fetch_row($res));


}


$startOffset=$startOffset+$recordsLimit;

}

/****************/

}

}

//}

$ratio=floor($supposeConverted*100/($numRows)).'%';

echo '<hr size="1"><br />Total Matched: '.$supposeConverted.' ('.$ratio.')';

$endtime=get_microtime();
$totaltime=sprintf ("%01.3f", ($endtime-$starttime));
echo '<br /><br />Total Time: '.$totaltime;

//}

echo '</body></html>';

?>